# Use for LINUX with SvgaLib.
# If you have problems using make change the label names bellow.
# Compiler options:
#   -g     compile with debug
#   -O2    optimization 2
#   -m486  use 486 instructions or -mpentium use Pentium instructions
#   -Wall  show all warnings
#   -pg    to enable profile (report profile: gprof foo.exe gmon.out)



COMPILER = g++

OPTIONS  = -O3 -m486 -Wall -DTRG_LINUXSVGA -ffast-math

EXTRA_LIBS = -lvga -lm

CMD_COPY_OBJ = cp *.o obj

CMD_DEL_OBJ  = rm *.o

CMD_COPY_EXE = cp *.exe ex

CMD_DEL_EXE  = rm *.exe

CMD_COPY_UTIL = cp *.exe util/bin

OBJ =	obj/screen.o		

HEADERS =	src/port/screen.h



# the common compilation make stuff
include makef/common.mak



# build only the library object files
library:	   screen commonlibrary



# build only the library examples
examples:	commontextexamples commongraphicsexamples



# build only the utilitys
utils:		commonutils



# SPECIFIC LIBRARY SOURCES
###########################################################

screen:		$(SRC_DIR)port/screen.cc
			   $(COMPILER) $(OPTIONS) -c $(SRC_DIR)port/screen.cc
				$(CMD_COPY_OBJ)
				$(CMD_DEL_OBJ)



# SPECIFIC EXAMPLES
###########################################################

# none



# SPECIFIC UTILS
###########################################################

# none
