/* Declare xwinapp.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_XWINAPP_H__



// signals file inclusion
#define __3DFC_XWINAPP_H__



class CXWindowApp {

   // Used for palette emulation:

   // one RGB struct 
   struct tagRGB {
      DWORD dwR;
      DWORD dwG;
      DWORD dwB;
   };
  
   // for 16BPP
   union tagFormat16 {

      struct {
         unsigned bitsB : 5;
         unsigned bitsG : 6;
         unsigned bitsR : 5;
      } stBits;

      INT nValue;
   };
  
   // for 15BPP
   union tagFormat15 {

      struct {
         unsigned bitsA : 1;
         unsigned bitsB : 5;
         unsigned bitsG : 5;
         unsigned bitsR : 5;
      } stBits;

      INT nValue;
   };
      
public:

   CXWindowApp ();
   ~CXWindowApp ();

public:

   // X app data
   Display*     m_pstDisplay;
   XtAppContext m_stApContext;
   Widget       m_stTopLevel;
   Widget       m_stShell;
   Widget       m_stBox;

   // hole screen
   // video resolution
   INT m_nDpyWidth;
   INT m_nDpyHeight;
   // color depth (bits per pixel)
   INT m_nBpp;

   // window data
   INT m_nScreenNum;
   Window   m_stWindow;
   XImage*  m_pXImg;
   GC       m_stGC;
   BYTE*    m_pyVid;     // point the X image for the window contents
   DWORD    m_dwResX;    // window X resolution
   DWORD    m_dwResY;    // window Y resolution
   BYTE*    m_pyVidPal;  // point the buffer for video memory, under palette (8BPP) mode
                         // At more then 8BPP is used for palette mode emulation.

   #ifdef COMP_SHAREMEMORY
   XShmSegmentInfo m_stShmi;
   XImage m_stShmImg;
   #endif

   // palette
   Colormap m_stColorMap;         // the palette, for 8BPP
   tagRGB   m_astPalEmul [ 256 ]; // store the palette for emulation at more than 8BPP
     
   // engine
   CEngine *m_poEngine;      // the engine object pointer
   CMem m_oFrameBufferRef;   // refer the output window area as frame buffer
   CKeyboard m_oKb;          // set keyboard functions acording keyboard events
   clock_t m_stClockStart;   // for timming
   DWORD m_dwFrames;

public:

   void mCreate ( char* szWinTitle, DWORD dwResX, DWORD dwResY, INT nArgc, char* pszArgv [] );
   void mDestroy ();
   void mWritePal ( CMem& oMem );
   void mShow ();
   void mExecApp ( CEngine& oEngine );

   // for palette emulation
   DWORD mFormatPixelColor ( DWORD dwPalCol );
};



extern CXWindowApp oAPP;    // the X aplication 



// end declarations
#endif
